import Flutter
import UIKit
import Appier

public class SwiftAirexSwiftPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "airex_swift_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftAirexSwiftPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

public func handle(_ call: FlutterMethodCall, result: FlutterResult) {

    let arguments:[String : Any] = call.arguments as! [String : Any]
    print(arguments)
    if "configure" == call.method {

        let appId:String? = arguments["appId"] as? String
        let appGroup:String? = arguments["appGroup"] as? String
        let isDev:Bool? = arguments["isDev"] as? Bool
        let valueAppId:String = appId ?? ""
        let valueAppGroup:String? = appGroup
        let valueIsDev:Bool = isDev ?? false
        print("valueAppId:\(valueAppId)")
        print("valueAppGroup:\(valueAppGroup)")
        print("valueIsDev:\(valueIsDev)")
        QGSdk.getSharedInstance().onStart(valueAppId, withAppGroup: valueAppGroup, setDevProfile: valueIsDev)
        result(nil)
        return
    } else if "logEvent" == call.method {
        /*
        var parameters: [String : Any]? = nil
        if call.arguments["parameters"]: [String : Any]? != nil {
            if let object = call.arguments["parameters"] {
                print("parameters: \(object)")
            }
            parameters = call.arguments["parameters"] as? [AnyHashable : Any]
        }

        let vts = call.arguments["vts"] as? NSNumber
        print("vtc class Name \(NSStringFromClass(type(of: vts).self))")

        let vtsCurr = call.arguments["vtsCurr"] as? NSNumber
        print("vtsCurr class Name \(NSStringFromClass(type(of: vtsCurr).self))")

        if call.arguments["eventName"] != nil {
            QGSdk.getSharedInstance().logEvent(call.arguments["eventName"], withParameters: parameters, withValueToSum: vts, withValueToSumCurrency: vtsCurr)
        }
        */
        result(nil)
    } else {
        result(FlutterMethodNotImplemented)
    }

  }
}
